#ifndef HELPERS_HPP
#define HELPERS_HPP

namespace hrt {

namespace internal {

template<typename T>
inline
T
abs(const T& value)
{ return value < T(0) ? -value : value; }

template<typename T>
inline
bool
within_bounds(const T& low, const T& value, const T& high)
{ return ((low < value) && (value < high)); }

} // namespace internal

} // namespace hrt

#endif // HELPERS_HPP
