#ifndef SCOPED_PRIORITY_CLASS_HPP
#define SCOPED_PRIORITY_CLASS_HPP

#include <windows.h>

namespace hrt {

namespace internal {

class scoped_priority_class
{
	scoped_priority_class(const scoped_priority_class&);						// not defined
	scoped_priority_class& operator=(const scoped_priority_class&); // not defined

public:
	//
	// CONSTRUCTORS
	//
	scoped_priority_class(int priority_class)
		: m_dismissed(false),
		m_old_priority_class(::GetPriorityClass(::GetCurrentProcess()))
	{
		::SetPriorityClass(::GetCurrentProcess(), priority_class);
	}

	~scoped_priority_class()
	{
		dismiss();
	}

	void dismiss()
	{
		if (!m_dismissed)
		{
			::SetPriorityClass(::GetCurrentProcess(), m_old_priority_class);
			m_dismissed = true;
		}
	}

	private:
		//
		// IMPLEMENTATION
		//
		bool	m_dismissed;
		int		m_old_priority_class;
};

} // namespace internal

} // namespace hrt

#endif // SCOPED_PRIORITY_CLASS_HPP
