#ifndef TIMER_HPP
#define TIMER_HPP

#include <hrt/time_span.hpp>
#include <hrt/time_stamp.hpp>

namespace hrt {

template<typename counter_type>
class timer
{
	typedef typename timer<counter_type> this_type;

public:

	typedef typename counter_type							counter_type;
	typedef typename time_stamp<counter_type>	time_stamp_type;
	typedef typename time_span<counter_type>	time_span_type;
	typedef typename counter_type::value_type					value_type;

public:
	//
	// CONSTRUCTORS
	//
	timer()
		: m_frequency(counter_type::frequency())
	{}

	//
	// ACCESSORS
	//
	static time_stamp_type now()
		{ return time_stamp_type(counter_type::value()); }
	value_type frequency() const
		{ return m_frequency; }

private:
	//
	// IMPLEMENTATION
	//
	value_type m_frequency;
};

} // namespace hrt

#endif // TIMER_HPP
