#ifndef SIMPLEEVENT_H
#define SIMPLEEVENT_H

#include <windows.h>
#include <string>

//
// SimpleEvent: Representation of a timestamped log event
//
template<typename TimeProvider>
struct SimpleEvent
{
	typedef typename TimeProvider::raw_value_type RawTime;

	SimpleEvent(RawTime rt, DWORD dwOriginatingThreadId, const std::string& sMsg)
		: m_rt(rt),
			m_dwOriginatingThreadId(dwOriginatingThreadId),
			m_sMsg(sMsg)
	{}

	RawTime			m_rt;
	DWORD				m_dwOriginatingThreadId;
	std::string	m_sMsg;
};

#endif // SIMPLEEVENT_H
